//   RW Catalog
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/catalog.hpp
// -Declarations of the baseline RW Catalog sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
class Catalog_b : public RW {
 public:
  Catalog_b();                                    // default ctor
  explicit Catalog_b(std::string const& handle);  // tag-parm'd ctor

  auto parse_threads(Hip const& tag) -> int;  // only for Master
  auto have_new(Hip const& tag) -> bool;      //  "

  void        bind_master(Hip const& tag);  // slave obj meant for Bumpmaster 's
  inline auto master() const -> Hip const& { return master_; }

 private:
  Hip master_{};

  Stampstack stamps_;
  bool       do_stamps_;
};

//------------------------------------------------------------------------------
class Catalog : public Catalog_b {
 public:
  Catalog();                                    // default ctor
  explicit Catalog(std::string const& handle);  // tag-parm'd ctor
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211204
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
