//    RW Site
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/site.hpp
// -Declarations of the baseline RW Site sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
class Site_b : public RW {
 public:
  Site_b();                                    // default ctor
  explicit Site_b(std::string const& handle);  // tag-parm'd ctor

  void        bind_master(Hip const& tag);  // slave obj meant for Bumpmaster 's
  inline auto master() const -> Hip const& { return master_; }

 private:
  Hip master_{};

  Stampstack stamps_;
  bool       do_stamps_;
};

//------------------------------------------------------------------------------
class Site : public Site_b {
 public:
  Site();                                    // default ctor
  explicit Site(std::string const& handle);  // tag-parm'd ctor
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211204
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
