// RW Bumpmaster Project
// =====================
// Imageboard downloader + archiver demo;  SAVE.EVERYTHING.ANON. :^)

// Filename: ./main_bumpmaster.cpp
// -The program's entry point

#include "incls_all.hpp"

void diag_bumpmaster(Bumpmaster const& bump);
void diag_bumpmaster_slaves(Bumpmaster const& bump);

//------------------------------------------------------------------------------
int main() try {
  puts("\nSAVE.EVERYTHING.ANON. :^)\n");  // TRACE:
  ///

  Bumpmaster bump{"bumpmaster"};
  diag_bumpmaster(bump);
  diag_bumpmaster_slaves(bump);

  ///
  puts("");

  // TEST: basic test of a (fake, for now) bumpmaster<->dollhouse
  // 'dolldrop-roundtripping' uri request
  string foo_page{"bar_page"};
  if (bump.dollhouse().ask_drop(bump.t(), "my_foo_domain.xyz")) {
    puts("");
    foo_page = bump.dollhouse().get_drop(bump.t());
  }
  cout << "foo_page: '" << foo_page << "'\n";

  ///
  puts("\n...leaving main()\n");  // TRACE:

} catch (runtime_error const& e) {
  cerr << "\n\n" << e.what() << "\n\n";
} catch (exception const& e) {
  // TBD:
} catch (...) {
  // TBD:
}

// DIAG:
//------------------------------------------------------------------------------
void diag_bumpmaster(Bumpmaster const& bump) {
  puts("");

  prt_tag(bump.t());
  prt_tag(bump.board().t(), "bump.board()\t");
  prt_tag(bump.catalog().t(), "bump.catalog()\t");
  prt_tag(bump.dollhouse().t(), "bump.dollhouse()");
  prt_tag(bump.page().t(), "bump.page()   \t");
  prt_tag(bump.post().t(), "bump.post()   \t");
  prt_tag(bump.site().t(), "bump.site()   \t");
  prt_tag(bump.thread().t(), "bump.thread()\t");

  puts("");
}

// DIAG:
//------------------------------------------------------------------------------
void diag_bumpmaster_slaves(Bumpmaster const& bump) {
  puts("");

  prt_tag(bump.t(), "bump, the Master\t");

  puts("");
  //
  prt_tag(bump.board().master(), "board's Master  \t");
  prt_tag(bump.catalog().master(), "catalog's Master\t");
  prt_tag(bump.page().master(), "page's Master   \t");
  prt_tag(bump.post().master(), "post's Master   \t");
  prt_tag(bump.site().master(), "site's Master   \t");
  prt_tag(bump.thread().master(), "thread's Master  \t");
  //
  // TEST:  (master == (slave's master))  equivalence:
  puts("");
  //
  cout << std::boolalpha;
  cout << "bump == board's Master :\t'" << (bump.t() == bump.board().master())
       << "'\n";
  cout << "bump == catalog's Master :\t'"
       << (bump.t() == bump.catalog().master()) << "'\n";
  cout << "bump == page's Master :  \t'" << (bump.t() == bump.page().master())
       << "'\n";
  cout << "bump == post's Master :  \t'" << (bump.t() == bump.post().master())
       << "'\n";
  cout << "bump == site's Master :  \t'" << (bump.t() == bump.site().master())
       << "'\n";
  cout << "bump == thread's Master :\t'" << (bump.t() == bump.thread().master())
       << "'\n";

  puts("");
}

//    --=^=--

// "Everyone's talking about IT & the Internet, and how advanced it's getting."

// rw_bumpmaster_demo.v211204
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
