// RW Sumomo's World! Project
// ==========================
// Animated avatars demo project; a pair of cute Chibitsu-grade robowaifus help

// Filename: ./main_sumomos_world.cpp
// -The program's entry point

#include "incls_all.hpp"

void init_sumomo(Sumomo& sumomo);
void init_kotoko(Kotoko& kotoko);

//------------------------------------------------------------------------------
int main() try {
  puts("\nWakey, wakey world...\n");  // TRACE:

  Sumomo sumomo{"Sumomo"};
  init_sumomo(sumomo);
  //
  sumomo.whistle().tweet();

  puts("");

  Kotoko kotoko{"Kotoko"};
  init_kotoko(kotoko);

  puts("");

  // DIAG:
  Waifusearch waifusearch{"waifusearch"};
  prt_tag(waifusearch.t());
  prt_tag(waifusearch.curator().t(), "waifusearch.curator()");

  // DIAG:
  Bumpmaster bumpmaster{"bumpmaster"};
  prt_tag(bumpmaster.t());
  prt_tag(bumpmaster.catalog().t(), "bumpmaster.catalog()");
  prt_tag(bumpmaster.dollhouse().t(), "bumpmaster.dollhouse()");
  prt_tag(bumpmaster.page().t(), "bumpmaster.page()\t");
  prt_tag(bumpmaster.post().t(), "bumpmaster.post()\t");
  prt_tag(bumpmaster.thread().t(), "bumpmaster.thread()\t");
  prt_tag(bumpmaster.site().t(), "bumpmaster.site()\t");

  // DIAG:
  Action action{"action"};
  prt_tag(action.t());
  Artstory artstory{"artstory"};
  prt_tag(artstory.t());
  Moveit moveit{"moveit"};
  prt_tag(moveit.t());
  prt_tag(moveit.bones().t(), "moveit.bones()   \t");
  Scene scene{"scene"};
  prt_tag(scene.t());

  // DIAG:
  Dollhouse dollhouse{"dollhouse"};
  prt_tag(dollhouse.t());
  prt_tag(dollhouse.electro().t(), "dollhouse.electro()\t");

  // DIAG:
  Terminal terminal{"terminal"};
  prt_tag(terminal.t());

  // DIAG:
  // Shell shell{};
  // shell.dollhouse().dock_me();
  // shell.dollhouse().charge_me();
  // shell.dollhouse().sleep_me();
  // shell.dollhouse().wake_me();
  // shell.dollhouse().store_me();

  // sumomo.shell().dollhouse().dock_me();
  // sumomo.shell().dollhouse().charge_me();
  // sumomo.shell().dollhouse().sleep_me();
  // sumomo.shell().dollhouse().wake_me();
  // sumomo.shell().dollhouse().store_me();

  puts("\n...leaving main()\n");  // TRACE:
} catch (runtime_error const& e) {
  cerr << "\n\n" << e.what() << "\n\n";
} catch (exception const& e) {
  // TBD:
} catch (...) {
  // TBD:
}

//------------------------------------------------------------------------------
void init_sumomo(Sumomo& sumomo) {
  sumomo.do_preflight();
  //
  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // DIAG:
  prt_tag(sumomo.t());
  prt_tag(sumomo.animeyes().t(), "sumomo.animeyes()\t");
  prt_tag(sumomo.atashi().t(), "sumomo.atashi() \t");
  prt_tag(sumomo.bones().t(), "sumomo.bones()  \t");
  prt_tag(sumomo.curator().t(), "sumomo.curator()\t");
  prt_tag(sumomo.dollhouse().t(), "sumomo.dollhouse()");
  prt_tag(sumomo.electro().t(), "sumomo.electro()\t");
  prt_tag(sumomo.face().t(), "sumomo.face()   \t");
  prt_tag(sumomo.gears().t(), "sumomo.gears()  \t");
  prt_tag(sumomo.hearsay().t(), "sumomo.hearsay()\t");
  prt_tag(sumomo.meido().t(), "sumomo.meido()  \t");
  prt_tag(sumomo.shell().t(), "sumomo.shell()  \t");

  puts("");

  prt_tag(sumomo.graphicom().t(), "sumomo.graphicom()\t");

  puts("");

  prt_tag(sumomo.confetti().t(), "sumomo.confetti() \t");
  prt_tag(sumomo.dustpan().t(), "sumomo.dustpan()   \t");
  prt_tag(sumomo.flags().t(), "sumomo.flags()   \t");
  prt_tag(sumomo.pompoms().t(), "sumomo.pompoms()\t");
  prt_tag(sumomo.tambourine().t(), "sumomo.tambourine()");
  prt_tag(sumomo.whisk().t(), "sumomo.whisk()   \t");
  prt_tag(sumomo.whistle().t(), "sumomo.whistle()\t");

  puts("");
}

//------------------------------------------------------------------------------
void init_kotoko(Kotoko& kotoko) {
  kotoko.do_preflight();
  //
  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // DIAG:
  prt_tag(kotoko.t());
  prt_tag(kotoko.animeyes().t(), "kotoko.animeyes()");
  prt_tag(kotoko.atashi().t(), "kotoko.atashi() \t");
  prt_tag(kotoko.bones().t(), "kotoko.bones()  \t");
  prt_tag(kotoko.curator().t(), "kotoko.curator()\t");
  prt_tag(kotoko.dollhouse().t(), "kotoko.dollhouse()");
  prt_tag(kotoko.electro().t(), "kotoko.electro()\t");
  prt_tag(kotoko.face().t(), "kotoko.face()   \t");
  prt_tag(kotoko.gears().t(), "kotoko.gears()  \t");
  prt_tag(kotoko.hearsay().t(), "kotoko.hearsay()\t");
  prt_tag(kotoko.meido().t(), "kotoko.meido()  \t");
  prt_tag(kotoko.shell().t(), "kotoko.shell()  \t");

  puts("");

  prt_tag(kotoko.graphicom().t(), "kotoko.graphicom()\t");

  puts("");
}

//    --=^=--

// "We just needed the pantsu for a parachute!"

// rw_sumomos_world_demo.v211204
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
