// RW Bumpmaster
// ==============
// Imageboard Retrieval & Archiving Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/curator/bumpmaster/bumpmaster.cpp
// -Definitions of the baseline RW Bumpmaster sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
Bumpmaster_b::Bumpmaster_b()
    : Bumpmaster_b{"bumpmaster_b_obj", Type::Bumpmaster} {}

//------------------------------------------------------------------------------
Bumpmaster_b::Bumpmaster_b(const std::string& handle, const Type type)
    : RW{handle, type} {}

//------------------------------------------------------------------------------
Bumpmaster::Bumpmaster() : Bumpmaster{"bumpmaster_obj"} {}

//------------------------------------------------------------------------------
Bumpmaster::Bumpmaster(std::string const& handle)
    : Bumpmaster_b{handle, Type::Bumpmaster} {
  preflight();
}

//------------------------------------------------------------------------------
void Bumpmaster::preflight() {
  //

  // bind all member slave objects to this master
  //
  board_.bind_master(t());
  catalog_.bind_master(t());
  page_.bind_master(t());
  post_.bind_master(t());
  site_.bind_master(t());
  thread_.bind_master(t());
}

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211204
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
