//  RW Foundations
// ================
// The RW Foundational Libraries

// Filename: ./src/rw/rw.cpp
// -Definitions of the baseline RW library

#include "incls_all.hpp"

namespace rw {

//------------------------------------------------------------------------------
RW::RW() {}

//------------------------------------------------------------------------------
RW::RW(std::string const& handle) : hip_{handle, rw_id++, this} {}

//------------------------------------------------------------------------------
RW::RW(std::string const& handle, Type const type)
    : hip_{handle, rw_id++, this, type} {}

//------------------------------------------------------------------------------
RW::~RW() {
  // prt_tag(hip_, "via RW::~RW() dtor \t");  // DIAG:
}

//------------------------------------------------------------------------------
auto RW::hdl() const -> std::string {
  return hip_.hdl;
}

//------------------------------------------------------------------------------
auto RW::id() const -> unsigned int {
  return hip_.id;
}

//------------------------------------------------------------------------------
auto RW::addr() const -> RW* {
  return hip_.ptr;
}

//------------------------------------------------------------------------------
auto RW::typ() const -> Type {
  return hip_.typ;
}

//------------------------------------------------------------------------------
auto RW::t() const -> Hip const& {
  return hip_;
}

//------------------------------------------------------------------------------
unsigned long int RW::rw_id{0};  // private static member

}  // namespace rw

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v211204
// Copyright (2021)
// License MIT(Expat) https://opensource.org/licenses/MIT
